#define _POSIX_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <assert.h>


void ThreadExecute( void (*func)() );
void ThreadReturn();
void func();
void loop( int n );
void check_buf( char *buf, char fill_char, size_t size );
void fill_buf( char *buf, char fill_char, size_t size );
extern "C" void ckpt();

main( int argc, char *argv[] )
{
	int		i;
	char	buf[ 1024 * 1024 ];
	char	fill_char = 'a';

	for( i = 0; i<10; i++, fill_char++ ) {
		printf( "i = %d\n", i );
		printf( "This should be a STACK address 0x%p\n", &i );
		fflush( stdout );
		fill_buf( buf, fill_char, sizeof(buf) );

		printf( "About to Ckpt from STACK\n" );
		fflush( stdout );
		ckpt();
		printf( "Returned from ckpt\n" );
		fflush( stdout );

		loop( 1 );
		ThreadExecute( func );
		check_buf( buf, fill_char, sizeof(buf) );
	}
	printf( "Normal End_Of_Job\n" );
	exit( 0 );
}

void
fill_buf( char *buf, char fill_char, size_t size )
{
	int		i;

	for( i=0; i<size; i++ ) {
		buf[i] = fill_char;
	}
}

void
check_buf( char *buf, char fill_char, size_t size )
{
	int		i;

	for( i=0; i<size; i++ ) {
		assert( buf[i] == fill_char );
	}
}

void
func()
{
	int		i;

	printf( "This should be a  DATA address 0x%p\n", &i );
	fflush( stdout );

	printf( "About to Ckpt from DATA\n" );
	fflush( stdout );
	ckpt();
	printf( "Returned from ckpt\n" );
	fflush( stdout );

	loop( 2 );
	ThreadReturn();
}

#define TRUE 1
#define FALSE 0
#define JMP_BUF_SP(env) (((long *)(env))[JMP_BUF_SP_INDEX])


#if defined(ULTRIX43)
#	define SETJMP _setjmp
#	define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 32

#elif defined(SUNOS41)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 2

#elif defined(SOLARIS2)
#   define SETJMP setjmp
#   define LONGJMP longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 1

#elif defined(OSF1)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 34

#elif defined(HPUX9)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown FALSE
#	define JMP_BUF_SP_INDEX 1

#elif defined(AIX32)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown TRUE
#	define JMP_BUF_SP_INDEX 3

#elif defined(IRIX5)
#   define SETJMP setjmp
#   define LONGJMP longjmp

#elif defined(HPUX9)
#   define SETJMP _setjmp
#   define LONGJMP _longjmp
#	define StackGrowsDown FALSE
#	define JMP_BUF_SP_INDEX 1

#elif defined(LINUX)
#   define StackGrowsDown TRUE
#   define JMP_BUF_SP_INDEX 4
#   define SETJMP setjmp
#   define LONGJMP longjmp

#else
#   error UNKNOWN PLATFORM
#endif

extern "C" {
	int SETJMP( jmp_buf env );
#if !defined(LINUX)
	void LONGJMP( jmp_buf env, int retval );
#else
	void LONGJMP( const jmp_buf env, int retval );
#endif
}

/*
  Switch to a temporary stack area in the DATA segment, then execute the
  given function.  Note: we save the address of the function in a
  global data location - referencing a value on the stack after the SP
  is moved would be an error.
*/
static void (*SaveFunc)();
static jmp_buf ReturnEnv;

// The stack is to be aligned on an 8-byte boundary on some
// machines. This is required so that double's can be pushed
// on the stack without any alignment problems.

const int	TmpStackSize = sizeof(char)*8192/sizeof(double);
static double	TmpStack[ TmpStackSize ];
void
ThreadExecute( void (*func)() )
{
	jmp_buf	env;
	SaveFunc = func;

	if( SETJMP(ReturnEnv) == 0 ) {
		if( SETJMP(env) == 0 ) {
				// First time through - move SP
			if( StackGrowsDown ) {
				JMP_BUF_SP(env) = (long)(TmpStack + TmpStackSize);
			} else {
				JMP_BUF_SP(env) = (long)TmpStack;
			}
			LONGJMP( env, 1 );
		} else {
				// Second time through - call the function
			SaveFunc();
		}
	} else {
		return;
	}
}

void
ThreadReturn()
{
	LONGJMP( ReturnEnv, 1 );
}

#define UNIT 10000

#if defined(ALPHA)
#	define LIM (800 * UNIT)
#elif defined(AIX32)
#	define LIM (225 * UNIT)
#elif defined(SPARC)
#	define LIM (260 * UNIT)
#elif defined(ULTRIX43)
#	define LIM (170 * UNIT)
#elif defined(HPPAR)
#	define LIM (260 * UNIT)
#elif defined(LINUX)
#	define LIM (100 * UNIT)
#endif

waste_a_second()
{
	int		i;

	for( i=0; i<LIM; i++ )
		;
}

void
loop( int n )
{
	int		i;

	for( i=0; i<n; i++ ) {
		waste_a_second();
	}

}
