#ifndef __CONDOR_MASTER
#define __CONDOR_MASTER

class deamon
{
public:
	char*	name_in_config_file;
	char*	log_filename_in_config_file;
	char*	flag_in_config_file;
	char*		process_name;
	char*		log_name;
	int		flag;  // whether the process runs here or not
	int		pid;
	int 		restarts;
	time_t		timeStamp;
};


// to add a new process as a condor deamon, just add one line in 
// the structure deamon_ptr defined in deamon.C . The first elemnt 
// is the string that is 
// looked for in the config file for the executable, and the
// second element is the parameter looked for in the confit
// file for the name of the corresponding log file.If no log
// file need be there, then put a zero in the second column.
// The third parameter is the name of a condor_config variable
// that is ckecked before the process is created. If it is zero, 
// then the process is created always. If it is a valid name,
// this name shud be set to true in the condor_config file for the
// process to be created.

// e.g. all processes except PVMD are started always. The PVMD
// deamon do not have any log files as the second column is 0.
// The PVMD is started only if the vbalus of PVMD_RUNS_HERE is
// set to TRUE in the config file


class Deamons
{
private:
	static deamon deamon_ptr[]; // initialized in deamon.C
	int	no_deamons;
public:
	Deamons();
	void 	InitParams();
	int	GetIndex(const char* process_name);
	void 	StartAllDeamons();
	int		StartDeamon(char* name);      // retuns pid
	void	Restart(int pid);              // process pid got killed somehow
	void    RestartMaster();      	// PVMD??
	void	SigalrmHandler();     
	void	SignalAll(int signal);	       // send signal to all :PVMD??
	char*   DeamonName(int pid);	       // full process path name
	char*	DeamonLog(int pid);	       // full log file path name
	char*	SymbolicName(int pid);	       // name as in config file
	int	NumberRestarts(int pid);        // number of restarts
	int	IsDeamon(int pid);	       // returns 1 if pid is a deamon
};


#if 0
#define BADSIG          ((void (*)(int))(-1))
#define SIG_IGN         ((void (*)(int))( 1))
#define SIG_DFL         ((void (*)(int))( 0))
#endif

#define MAXIMUM(a,b) ((a)>(b)?(a):(b))

#endif /* __CONDOR_MASTER */
