/* 
** Copyright 1994 by Miron Livny, and Mike Litzkow
** 
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted,
** provided that the above copyright notice appear in all copies and that
** both that copyright notice and this permission notice appear in
** supporting documentation, and that the names of the University of
** Wisconsin and the copyright holders not be used in advertising or
** publicity pertaining to distribution of the software without specific,
** written prior permission.  The University of Wisconsin and the 
** copyright holders make no representations about the suitability of this
** software for any purpose.  It is provided "as is" without express
** or implied warranty.
** 
** THE UNIVERSITY OF WISCONSIN AND THE COPYRIGHT HOLDERS DISCLAIM ALL
** WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE UNIVERSITY OF
** WISCONSIN OR THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT
** OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
** OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
** OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
** OR PERFORMANCE OF THIS SOFTWARE.
** 
** Author:  Mike Litzkow
**
*/ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

extern "C" void ckpt();

class TestObj {
public:
	TestObj( const char * );
	void display();
	void setString( const char *str );
private:
	char	*string;
};

TestObj::TestObj( const char *init )
{
	string = new char[ strlen(init) + 1 ];
	assert( string );
	strcpy( string, init );
}

void
TestObj::setString( const char *str )
{
	delete [] string;
	string = new char[ strlen(str) + 1 ];
	assert( string );
	strcpy( string, str );
}

void
TestObj::display()
{
	printf( "\"%s\"\n", string );
}

TestObj MyObj( "Hello World" );

int
main()
{
	MyObj.display();
	MyObj.setString( "Goodby World" );

	ckpt();

	MyObj.display();

	printf( "Normal End Of Job\n" );

	exit( 0 );
	return 0;
}
