/* 
** Copyright 1994 by Miron Livny, and Mike Litzkow
** 
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted,
** provided that the above copyright notice appear in all copies and that
** both that copyright notice and this permission notice appear in
** supporting documentation, and that the names of the University of
** Wisconsin and the copyright holders not be used in advertising or
** publicity pertaining to distribution of the software without specific,
** written prior permission.  The University of Wisconsin and the 
** copyright holders make no representations about the suitability of this
** software for any purpose.  It is provided "as is" without express
** or implied warranty.
** 
** THE UNIVERSITY OF WISCONSIN AND THE COPYRIGHT HOLDERS DISCLAIM ALL
** WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE UNIVERSITY OF
** WISCONSIN OR THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT
** OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
** OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
** OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
** OR PERFORMANCE OF THIS SOFTWARE.
** 
** Author:  Mike Litzkow
**
*/ 

#define _POSIX_SOURCE

#include "condor_common.h"
#include "condor_constants.h"
#include "condor_xdr.h"
#include "condor_debug.h"
#include "startup.h"
#include "xdr_lib.h"

static char *_FileName_ = __FILE__;

xdr_startup_info( XDR *xdrs, STARTUP_INFO *s )
{
	if( !xdr_int(xdrs,&s->version_num) )
		return FALSE;
	if( !xdr_int(xdrs,&s->cluster) )
		return FALSE;
	if( !xdr_int(xdrs,&s->proc) )
		return FALSE;
	if( !xdr_int(xdrs,&s->job_class) )
		return FALSE;
	if( !xdr_uid_t(xdrs,&s->uid) )
		return FALSE;
	if( !xdr_gid_t(xdrs,&s->gid) )
		return FALSE;
	if( !xdr_pid_t(xdrs,&s->virt_pid) )
		return FALSE;
	if( !xdr_int(xdrs,&s->soft_kill_sig) )
		return FALSE;
	if( !xdr_string(xdrs,&s->cmd,_POSIX_PATH_MAX) )
		return FALSE;
	if( !xdr_string(xdrs,&s->args,_POSIX_PATH_MAX) )
		return FALSE;
	if( !xdr_string(xdrs,&s->env,_POSIX_PATH_MAX) )
		return FALSE;
	if( !xdr_string(xdrs,&s->iwd,_POSIX_PATH_MAX) )
		return FALSE;
	if( !xdr_int(xdrs,&s->ckpt_wanted) )
		return FALSE;
	if( !xdr_int(xdrs,&s->is_restart) )
		return FALSE;
	if( !xdr_int(xdrs,&s->coredump_limit_exists) )
		return FALSE;
	if( !xdr_int(xdrs,&s->coredump_limit) )
		return FALSE;

	return TRUE;
}
