/* 
** Copyright 1994 by Miron Livny, and Mike Litzkow
** 
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted,
** provided that the above copyright notice appear in all copies and that
** both that copyright notice and this permission notice appear in
** supporting documentation, and that the names of the University of
** Wisconsin and the copyright holders not be used in advertising or
** publicity pertaining to distribution of the software without specific,
** written prior permission.  The University of Wisconsin and the 
** copyright holders make no representations about the suitability of this
** software for any purpose.  It is provided "as is" without express
** or implied warranty.
** 
** THE UNIVERSITY OF WISCONSIN AND THE COPYRIGHT HOLDERS DISCLAIM ALL
** WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE UNIVERSITY OF
** WISCONSIN OR THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT
** OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
** OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
** OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
** OR PERFORMANCE OF THIS SOFTWARE.
** 
** Author:  Mike Litzkow
**
*/ 


#include <sys/types.h>
#include <sys/mount.h>
#include <rpc/types.h>
#include <rpc/xdr.h>

#include "trace.h"
#include "except.h"
#include "xdr_lib.h"
#include "debug.h"

#ifndef LINT
static char *_FileName_ = __FILE__;		/* Used by EXCEPT (see except.h)     */
#endif LINT

int
xdr_fsid_t( xdrs, ptr )
XDR		*xdrs;
fsid_t	*ptr;
{
	quad	*quad_ptr = (quad *)ptr;

	XDR_ASSERT( xdr_int(xdrs,&quad_ptr->val[0]) );
	XDR_ASSERT( xdr_int(xdrs,&quad_ptr->val[1]) );
}

xdr_statfs(xdrs, ptr)
register XDR *xdrs;
register struct statfs *ptr;
{
	XDR_ASSERT( xdr_short(xdrs,&ptr->f_type) );
	XDR_ASSERT( xdr_short(xdrs,&ptr->f_flags) );
	XDR_ASSERT( xdr_int(xdrs,&ptr->f_fsize) );
	XDR_ASSERT( xdr_int(xdrs,&ptr->f_bsize) );
	XDR_ASSERT( xdr_int(xdrs,&ptr->f_blocks) );
	XDR_ASSERT( xdr_int(xdrs,&ptr->f_bavail) );
	XDR_ASSERT( xdr_int(xdrs,&ptr->f_files) );
	XDR_ASSERT( xdr_int(xdrs,&ptr->f_ffree) );
	XDR_ASSERT( xdr_fsid_t(xdrs,&ptr->f_fsid) );
	XDR_ASSERT( xdr_opaque(xdrs,ptr->f_spare,sizeof(ptr->f_spare)) );
	XDR_ASSERT( xdr_opaque(xdrs,ptr->f_mntonname,sizeof(ptr->f_mntonname)) );
	XDR_ASSERT( xdr_opaque(xdrs,ptr->f_mntfromname,sizeof(ptr->f_mntfromname)));
	XDR_ASSERT( xdr_opaque(xdrs,&ptr->mount_info,sizeof(ptr->mount_info)) );

	return( TRUE );
}
