
/* 
** Copyright 1994 by Miron Livny, and Mike Litzkow
** 
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted,
** provided that the above copyright notice appear in all copies and that
** both that copyright notice and this permission notice appear in
** supporting documentation, and that the names of the University of
** Wisconsin and the copyright holders not be used in advertising or
** publicity pertaining to distribution of the software without specific,
** written prior permission.  The University of Wisconsin and the 
** copyright holders make no representations about the suitability of this
** software for any purpose.  It is provided "as is" without express
** or implied warranty.
** 
** THE UNIVERSITY OF WISCONSIN AND THE COPYRIGHT HOLDERS DISCLAIM ALL
** WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE UNIVERSITY OF
** WISCONSIN OR THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT
** OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
** OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
** OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
** OR PERFORMANCE OF THIS SOFTWARE.
** 
** Author:  Mike Litzkow
**
*/ 


#include <sys/types.h>
#include <rpc/types.h>
#include <rpc/xdr.h>
#include <sys/utsname.h>

#include "trace.h"
#include "except.h"

#ifndef LINT
static char *_FileName_ = __FILE__;		/* Used by EXCEPT (see except.h)     */
#endif LINT

xdr_utsname( xdrs, uptr )
XDR *xdrs;
struct utsname *uptr;
{
	if( !xdr_string(xdrs,uptr->sysname,_SYS_NMLN) ) {
		return FALSE;
	}
	if( !xdr_string(xdrs,uptr->nodename,_SYS_NMLN) ) {
		return FALSE;
	}
	if( !xdr_string(xdrs,uptr->release,_SYS_NMLN) ) {
		return FALSE;
	}
	if( !xdr_string(xdrs,uptr->version,_SYS_NMLN) ) {
		return FALSE;
	}
	if( !xdr_string(xdrs,uptr->machine,_SYS_NMLN) ) {
		return FALSE;
	}
}
